-- ok so mooooost (~~100%~~) of this is just translated from the source code for conveniency and consistency sakes. 
-- essentially the code is so huge and long and repetitive that i spit it into its own file.
-- sorry for bad naming.
-- ...also sorry for lack of comments.

-- objects, sounds, sprites
freeslot("SPR_SWPI", "S_ENSWAP", "MT_ENSWAP", "sfx_swap", "sfx_swapf", "sfx_eswap", "S_SWAP_ICON1", "S_SWAP_ICON2", "MT_SWAP_ICON", "S_SWAP_BOX", "MT_SWAP_BOX", "SPR_TVSW", "S_ERND_ICON1", "S_ERND_ICON2", "MT_ERND_ICON", "S_ERND_BOX", "MT_ERND_BOX", "SPR_TVER")
states[S_ENSWAP] = {SPR_SWPI,   FF_FULLBRIGHT, 2, NULL, 0, 0, S_NULL}
mobjinfo[MT_ENSWAP] = {
	spawnstate = S_ENSWAP,
	spawnhealth = 1000,
	reactiontime = 8,
	speed = 8,
	radius = 16*FRACUNIT,
	height = 32*FRACUNIT,
	dispoffset = 111,
	mass = 16,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOGRAVITY|MF_SCENERY,
}
S_sfx[sfx_swap].caption = "Swap"
S_sfx[sfx_swapf].caption = "Swap Fail"
states[S_SWAP_ICON1] = {SPR_TVSW, FF_ANIMATE|2, 18, NULL, 3, 4, S_SWAP_ICON2}
states[S_SWAP_ICON2] = {SPR_TVSW, 2, 18, A_SwapBox, 0, 0, S_NULL}
mobjinfo[MT_SWAP_ICON] = {
	spawnstate = S_SWAP_ICON1,
	spawnhealth = 1,
	seesound = sfx_eswap,
	reactiontime = 10,
	speed = 2*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	mass = 100,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON,
}
states[S_SWAP_BOX] = {SPR_TVSW, 0, 2, NULL, 0, 0, S_BOX_FLICKER}
mobjinfo[MT_SWAP_BOX] = {
	doomednum = 1092,
	spawnstate = S_SWAP_BOX,
	reactiontime = 8,
	painstate = S_SWAP_BOX,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	mass = 100,
	damage = MT_SWAP_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
}
states[S_ERND_ICON1] = {SPR_TVER, FF_ANIMATE|2, 18, NULL, 3, 4, S_ERND_ICON2}
states[S_ERND_ICON2] = {SPR_TVER, 2, 18, A_ScrambleBox, 0, 0, S_NULL}
mobjinfo[MT_ERND_ICON] = {
	spawnstate = S_ERND_ICON1,
	spawnhealth = 1,
	seesound = sfx_eswap,
	reactiontime = 10,
	speed = 2*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	mass = 100,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON,
}
states[S_ERND_BOX] = {SPR_TVER, 0, 2, NULL, 0, 0, S_BOX_FLICKER}
mobjinfo[MT_ERND_BOX] = {
	doomednum = 1093,
	spawnstate = S_ERND_BOX,
	reactiontime = 8,
	painstate = S_ERND_BOX,
	deathstate = S_BOX_POP1,
	deathsound = sfx_pop,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	mass = 100,
	damage = MT_ERND_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR,
}

freeslot(
	"S_ENC_ICON1",
	"S_ENC_ICON2",
	"S_ENC_BOX",
	"MT_ENC_ICON",
	"MT_ENC_BOX",
	"S_ENC_POP1",
	"sfx_e1up"
)

local mts = {
	MT_RING_BOX,
	MT_PITY_BOX,
	MT_BUBBLEWRAP_BOX,
	MT_FLAMEAURA_BOX,
	MT_THUNDERCOIN_BOX,
	MT_SWAP_BOX,
	MT_ERND_BOX,
}

-- Function: A_1upThinker
--
-- Description: Used by the 1up box to show the player's face.
--
-- var1 = unused
-- var2 = unused
--
function A_ExtraCharThinker(actor)
	local dist = INT32_MAX
	local temp
	local closestplayer = -1

	for player in players.iterate do
		if not (player and player.valid) or player.bot == BOT_2PAI or player.bot == BOT_2PHUMAN or player.spectator then
			continue
		end

		if not player.mo then
			continue
		end

		if (netgame or multiplayer) and player.playerstate ~= PST_LIVE then
			continue
		end

		temp = P_AproxDistance(player.mo.x-actor.x, player.mo.y-actor.y)

		if temp < dist then
			closestplayer = #player
			dist = temp
		end
	end

	if closestplayer == -1
	or (players
	and players[closestplayer]
	and players[closestplayer].valid
	and players[closestplayer].extralist
	and actor.cs
	and players[closestplayer].extralist[actor.cs]
	and players[closestplayer].extralist[actor.cs].sprites[SPR2_LIFE].numframes == 0) then
	-- Closest player not found (no players in game?? may be empty dedicated server!), or does not have correct sprite.
		if actor.tracer then
			P_RemoveMobj(actor.tracer)
			actor.tracer = nil
		end
		return
	end

	-- custom
	if players[closestplayer].extralist and #players[closestplayer].extralist > 0 then
		if not actor.cs then
			actor.cs = 1
		end
		if not (leveltime%2) then
			actor.cs = $+1
		end
		if actor.cs > #players[closestplayer].extralist then
			actor.cs = 1
		end
		local sknn = players[closestplayer].extralist[actor.cs].name

		-- We're using the overlay, so use the overlay 1up box (no text)
		actor.sprite = SPR_TV1P

		if not actor.tracer then
			actor.tracer = P_SpawnMobj(actor.x, actor.y, actor.z, MT_OVERLAY)
			actor.tracer.target = actor
			actor.tracer.skin = skins[players[closestplayer].skin].name -- required here to prevent spr2 default showing stand for a single frame
			actor.tracer.state = actor.info.seestate

			-- The overlay is going to be one tic early turning off and on
			-- because it's going to get its thinker run the frame we spawned it.
			-- So make it take one tic longer if it just spawned.
			actor.tracer.tics = $ + 1
		end

		actor.tracer.color = skins[sknn].prefcolor
		actor.tracer.skin = sknn
	elseif players[closestplayer].extralist then
		if not actor.cs then
			actor.cs = 1
		end
		if not (leveltime%2) then
			actor.cs = $+1
		end
		if actor.cs > #mts then
			actor.cs = 1
		end
		local mt = mts[actor.cs]

		if actor.tracer then
			P_RemoveMobj(actor.tracer)
			actor.tracer = nil
		end

		if actor.state == S_ENC_BOX then
			actor.sprite = states[mobjinfo[mt].spawnstate].sprite
		end
	end
end

-- Function: A_MonitorPop
--
-- Description: Used by monitors when they explode.
--
-- var1 = unused
-- var2 = unused
--
function A_EncorePop(actor)
	local item = 0
	local newmobj

	-- Spawn the "pop" explosion.
	if actor.info.deathsound then
		S_StartSound(actor, actor.info.deathsound)
	end
	P_SpawnMobjFromMobj(actor, 0, 0, actor.height/4, MT_EXPLODE)

	-- We're dead now. De-solidify.
	actor.health = 0
	actor.flags = $ & ~MF_SOLID
	actor.flags = $|MF_NOCLIP

	if actor.info.damage ~= MT_UNKNOWN then
		if #actor.target.player.extralist > 0 then
			item = actor.info.damage
		else
			item = mobjinfo[mts[actor.cs]].damage
		end
	end

	if item == 0 then
		return
	end

	newmobj = P_SpawnMobjFromMobj(actor, 0, 0, 13*FRACUNIT, item)
	newmobj.target = actor.target -- Transfer target

	if item == MT_ENC_ICON
		-- custom
		newmobj.sknn = newmobj.target.player.extralist[actor.cs].name

		if actor.tracer then -- Remove the old lives icon.
			P_RemoveMobj(actor.tracer)
		end

		if not newmobj.target
		 or not newmobj.target.player
		 or not newmobj.target.skin
		 or skins[newmobj.sknn].sprites[SPR2_LIFE].numframes == 0 then
			return -- No lives icon for this player, use the default.
		else -- Spawn the lives icon.
			local livesico = P_SpawnMobjFromMobj(newmobj, 0, 0, 0, MT_OVERLAY)
			livesico.target = newmobj
			newmobj.tracer = livesico

			livesico.color = skins[newmobj.sknn].prefcolor
			livesico.skin = newmobj.sknn
			livesico.state = newmobj.info.seestate

			-- We're using the overlay, so use the overlay 1up sprite (no text)
			newmobj.sprite = SPR_TV1P
		end
	end

	-- Run a linedef executor immediately upon popping
	-- You may want to delay your effects by 18 tics to sync with the reward giving
	if actor.spawnpoint and actor.lastlook then
		P_LinedefExecute(actor.lastlook, actor.target, NULL)
	end
end

states[S_ENC_ICON1] = {SPR_TV1U, FF_ANIMATE|2, 18, NULL, 3, 4, S_ENC_ICON2}
states[S_ENC_ICON2] = {SPR_TV1U, 2, 18, A_ExtraChar,  0, 0, S_NULL}
states[S_ENC_BOX] = {SPR_TV1U, 0, 2, A_ExtraCharThinker, 0, 0, S_BOX_FLICKER}
states[S_ENC_POP1] = {SPR_MSTV, 0,  4, A_EncorePop, 0, 0, S_BOX_POP2}

mobjinfo[MT_ENC_ICON] = {
	spawnstate = S_ENC_ICON1,
	spawnhealth = 1,
	seesound = sfx_e1up,
	seestate = S_PLAY_ICON1,
	reactiontime = 8,
	speed = 2*FRACUNIT,
	radius = 8*FRACUNIT,
	height = 14*FRACUNIT,
	mass = 100,
	damage = 62*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_NOCLIP|MF_SCENERY|MF_NOGRAVITY|MF_BOXICON
}

mobjinfo[MT_ENC_BOX] = {
	doomednum = 1094,
	spawnstate = S_ENC_BOX,
	spawnhealth = 1,
	seestate = S_PLAY_BOX1,
	reactiontime = 8,
	painstate = S_ENC_BOX,
	deathstate = S_ENC_POP1,
	deathsound = sfx_pop,
	speed = 1,
	radius = 18*FRACUNIT,
	height = 40*FRACUNIT,
	mass = 100,
	damage = MT_ENC_ICON,
	flags = MF_SOLID|MF_SHOOTABLE|MF_MONITOR
}
