-- ok so a lot of this code is descendant from the legacy encore mode. it works and it is not that big or buggy as the rest of it so

addHook("MobjThinker", function(monitor)
	if(monitor and monitor.valid)
	and (gametype == GT_ENCORE or not multiplayer)
		local newmon = P_SpawnMobj(monitor.x, monitor.y, monitor.z, MT_ENC_BOX)
		newmon.angle = monitor.angle
		newmon.momx = monitor.momx
		newmon.momy = monitor.momy
		newmon.momz = monitor.momz
		P_RemoveMobj(monitor)
		return
	end
end, MT_1UP_BOX)

local function replacewithrandom(monitor)
	if(monitor and monitor.valid)
	and (gametype == GT_ENCORE or not multiplayer)
		local newmon = P_SpawnMobj(monitor.x, monitor.y, monitor.z, MT_ERND_BOX)
		newmon.angle = monitor.angle
		newmon.momx = monitor.momx
		newmon.momy = monitor.momy
		newmon.momz = monitor.momz
		P_RemoveMobj(monitor)
		return
	end
end

addHook("MobjThinker", replacewithrandom, MT_SCORE10K_BOX)

local function replacewithswap(monitor)
	if(monitor and monitor.valid)
	and (gametype == GT_ENCORE or not multiplayer)
		local newmon = P_SpawnMobj(monitor.x, monitor.y, monitor.z, MT_SWAP_BOX)
		newmon.angle = monitor.angle
		newmon.momx = monitor.momx
		newmon.momy = monitor.momy
		newmon.momz = monitor.momz
		P_RemoveMobj(monitor)
		return
	end
end

addHook("MobjThinker", replacewithswap, MT_RECYCLER_BOX)

local function replacerandomly(monitor)
	if mapheaderinfo[gamemap].noencorerandomizer then
		return
	end
	
	local rng = A_SeedRng_Get()
	if (gametype == GT_ENCORE or not multiplayer)
		if(server.seedrngstateplus == nil)
			server.seedrngstateplus = rng.Create(true, 1, 2, 3, 4)
		end
		
		if(monitor and monitor.valid)
			and(leveltime == 0)
			if(monitor.randomchance == nil)
				monitor.randomchance = rng.GetByte(server.seedrngstateplus)
			end
			if(monitor.randomchance <= 128)
				local mtype = MT_SWAP_BOX
				if(monitor.randomchance < 128/2)
					mtype = MT_ERND_BOX
				end
				local newmon = P_SpawnMobj(monitor.x, monitor.y, monitor.z, mtype)
				newmon.angle = monitor.angle
				newmon.momx = monitor.momx
				newmon.momy = monitor.momy
				newmon.momz = monitor.momz
				P_RemoveMobj(monitor)
				return
			end
		end
	end
end

addHook("MobjThinker", replacerandomly, MT_RING_BOX)
addHook("MobjThinker", replacerandomly, MT_ATTRACT_BOX)
addHook("MobjThinker", replacerandomly, MT_FORCE_BOX)
addHook("MobjThinker", replacerandomly, MT_ARMAGEDDON_BOX)
addHook("MobjThinker", replacerandomly, MT_WHIRLWIND_BOX)
addHook("MobjThinker", replacerandomly, MT_ELEMENTAL_BOX)
addHook("MobjThinker", replacerandomly, MT_PITY_BOX)
